
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>用微信控制深度学习训练的Keras插件 - #Geek Time / iVAN</title>

    <meta name="description" content="用微信控制深度学习训练的Keras插件 - #Geek Time &quot; 天清 PaperWeekly 交流二群群友 关注音乐生成和量化交易 创意来源 深度学习训练是一个非常耗时.枯燥的过程:一次训练少则几个小时,多则数天,而且中途能人为干预的机会更是少之又少,在大部分时间里能做的只有等待. 不少人都有这样强迫症,脚本开始运行后会不停的看准确率和 loss,就像像球迷看球赛.股民盯报价一样刺激.一般来说,想要监控深度学习训练,只能使用 ssh 或者 Tensorboard.一旦需要外出,只能通过手机监控深度学习,操作十分麻烦,于是只能无奈地守在电脑前空耗 ...">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/bootstrap.css" rel="stylesheet">
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
  <script>
  var _hmt = _hmt || [];
  (function() {
    var hm = document.createElement("script");
    hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
    var s = document.getElementsByTagName("script")[0]; 
    s.parentNode.insertBefore(hm, s);
  })();
  </script>
 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="https://pic.ikafan.com/staticx/iamivan/2/assets/logo.png" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/">首页</a></li>
            <li><a href="/tag/互联网/">互联网</a></li>
            <li><a href="/tag/java/">java</a></li>
            <li><a href="/tag/mysql/">mysql</a></li>
            <li><a href="/tag/android/">Android</a></li>
            <li><a href="/tag/ios/">IOS</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    <div id="main" class="col-md-8">


<h1 class="mtitle">用微信控制深度学习训练的Keras插件 - #Geek Time</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>

    	<section>
		<article class="clearfix">
		<p>“</p>
<p><strong>天清</strong></p>
<p>PaperWeekly 交流二群群友</p>
<p>关注音乐生成和量化交易</p>
<h2><strong>创意来源</strong></h2>
<p>深度学习训练是一个非常耗时、枯燥的过程：一次训练少则几个小时，多则数天，而且中途能人为干预的机会更是少之又少，在大部分时间里能做的只有等待。</p>
<p>不少人都有这样强迫症，脚本开始运行后会不停的看准确率和 loss，就像像球迷看球赛、股民盯报价一样刺激。一般来说，想要监控深度学习训练，只能使用 ssh 或者 Tensorboard。一旦需要外出，只能通过手机监控深度学习，操作十分麻烦，于是只能无奈地守在电脑前空耗生命。</p>
<p>我们急需一种办法能够将我们从电脑前解放，让监控深度学习变得简单方便，不再受时间、空间和平台的限制。在当今社会，有什么东西是在任何时间任何地点我们都能使用的呢？答案只有一个：<strong>微信</strong>。</p>
<p>微信是每个中国人接入社会的重要接口，我们用微信在地铁上看鸡汤、在商场使用电子支付、瘫在沙发上刷朋友圈……总之，微信几乎包办了我们生活中的一切，让人产生一种错觉，在不久的未来手机上只需要装微信一个软件就够了。那么，如果微信能把监控深度学习也包办了岂不是妙哉？</p>
<p>在知乎上看到<strong>@Coldwings </strong>- <strong>利用微信监管你的TF训练</strong>（https://zhuanlan.zhihu.com/p/25597975?group_id=822180572054048768）的用微信监控 Tensorflow 训练的项目，很受启发，决定开发一款用微信监控 Keras 训练的插件。欢迎 fork 这个项目的 GitHub：https://github.com/QuantumLiu/wechat_callback。</p>
<p><strong>原理介绍</strong></p>
<p>本插件基于 python3.5，python2.7 需要将_thread 改为 thread。当 import 程序文件时，将首先通过 ItChat（https://github.com/littlecodersh/ItChat）在服务器扫码登录微信（网页版）。</p>
<p>插件的主体是 sendmessage()，一个 Keras 的 keras.callbacks.Callback() 类，训练时被传入 fit() 方法的 callbacklist。在 on_train_begin(self, logs={}) 时，利用 @itchat.msg_register(TEXT) 注册针对不同命令的响应方法，启动新线程开始实时监控命令。</p>
<p>对命令的识别采用的是 python 的 if any((k in text) for k in cmdlist): 方法，即只要发送的消息内容包含符合条件的关键词即可出发，冗余字符不影响命令的触发。</p>
<p>训练过程中，由手机微信与“文件传输助手”间的通讯来实现命令的传递与内容反馈。</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvbW1iaXoucXBpYy5jbi9tbWJpel9wbmcvVkJjRDAyakZoZ21OeUk0QkdsMlQ4dFdQbEl6Y0VWa3hvSDBtRndtaWFZbW1YaWFjNWdRZFJMVXdhSGtQWUZrZjZNSDQyQTk3ZEFNUDI5TGliQTFTdlZyNlEvNjQwP3d4X2ZtdD1wbmcmYW1wO3RwPXdlYnAmYW1wO3d4ZnJvbT01JmFtcDt3eF9sYXp5PTE=.jpg"></p>
<p>如图，“获取图表{batches}”和“gpu[MEMORY TEMPERATURE]”是使用者本人发送的命令，服务器响应命令，以给文件助手发送消息的方式反馈内容（图表、汇报和状态）。</p>
<p><strong></strong></p>
<h2><strong>主要功能</strong></h2>
<p>目前已经实现了被动监控、主动查询、远程关机/停止训练等多项功能。</p>
<p>1. <strong>实时监控</strong><strong>：</strong>在每个epoch结束后，自动发送<strong>本epoch训练信息</strong>以及两张分别代表所有<strong>batch</strong>和<strong>epoch</strong>信息的图表至文件传输助手。</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvbW1iaXoucXBpYy5jbi9tbWJpel9wbmcvVkJjRDAyakZoZ21OeUk0QkdsMlQ4dFdQbEl6Y0VWa3h6cEpDQnVPNnVOQkdTNENrZ2R4VE5wNVU1NHUxdkdMSDIzd3F5RUxjcFN1VDI2WHBPdGwxRVEvNjQwP3d4X2ZtdD1wbmcmYW1wO3RwPXdlYnAmYW1wO3d4ZnJvbT01JmFtcDt3eF9sYXp5PTE=.jpg"></p>
<p>2. <strong>主动查询：</strong>在训练开始后的任意时刻，发送特定格式的指令，可获得指定查询项的信息。目前支持 batch 和 epoch 的各个指标的信息、显卡状态信息。</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvbW1iaXoucXBpYy5jbi9tbWJpel9wbmcvVkJjRDAyakZoZ21OeUk0QkdsMlQ4dFdQbEl6Y0VWa3gydHJzenJJalZCc3gwS0diaWJSajZ3RWVYZ3dvc0lKR2pDREJwT3ZkTGRmeG84UDVyTXJnc3hBLzY0MD93eF9mbXQ9cG5nJmFtcDt0cD13ZWJwJmFtcDt3eGZyb209NSZhbXA7d3hfbGF6eT0x.jpg"></p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvbW1iaXoucXBpYy5jbi9tbWJpel9wbmcvVkJjRDAyakZoZ21OeUk0QkdsMlQ4dFdQbEl6Y0VWa3hObXczYkRQaWF0dHFlSVFKaWF2bkJRYWEycGpodEliemY1bXJYUDBZWUZNamVodjd4NzFQUDNhZy82NDA/d3hfZm10PXBuZyZhbXA7dHA9d2VicCZhbXA7d3hmcm9tPTUmYW1wO3d4X2xhenk9MQ==.jpg"></p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvbW1iaXoucXBpYy5jbi9tbWJpel9wbmcvVkJjRDAyakZoZ21OeUk0QkdsMlQ4dFdQbEl6Y0VWa3hjVVdFenV1NVFiZmF1WTFHUUdOaWNKYTloaWJPc1huaGhNb2REMVpGcVc4V1VZMmU1TFhQT1JGdy82NDA/d3hfZm10PXBuZyZhbXA7dHA9d2VicCZhbXA7d3hmcm9tPTUmYW1wO3d4X2xhenk9MQ==.jpg"></p>
<p>3. <strong>远程控制：</strong>当你觉得训练已经收敛，或者因任何原因需要停止训练时，可以优雅地终止训练甚至关机。Keras 的 fit 方法中，可以通过在 callback 设置 self.model.stop_training = True 来实现在当前 epoch 结束时终止训练，否则只能 Ctrl+C 暴力停止。利用本插件，可以使用特殊格式的指令来指定停止 epoch、立刻停止训练，甚至关机和取消关机。</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvbW1iaXoucXBpYy5jbi9tbWJpel9wbmcvVkJjRDAyakZoZ21OeUk0QkdsMlQ4dFdQbEl6Y0VWa3hTZG9XcW1iaFhyVVpEcWYyZlQyZUpaMjE0UjVUWDljY3kzcDl3SWw3SzQ5cnhUcmpabXplN1EvNjQwP3d4X2ZtdD1wbmcmYW1wO3RwPXdlYnAmYW1wO3d4ZnJvbT01JmFtcDt3eF9sYXp5PTE=.jpg"></p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvbW1iaXoucXBpYy5jbi9tbWJpel9wbmcvVkJjRDAyakZoZ21OeUk0QkdsMlQ4dFdQbEl6Y0VWa3hJMGliMmNXcGR5RkV1UFY4S1BTRmpYN1lpY2ljdDlJQVRVaE1kNDJXa2Jubm1SWFkxWm1WMHl3YWcvNjQwP3d4X2ZtdD1wbmcmYW1wO3RwPXdlYnAmYW1wO3d4ZnJvbT01JmFtcDt3eF9sYXp5PTE=.jpg"></p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvbW1iaXoucXBpYy5jbi9tbWJpel9wbmcvVkJjRDAyakZoZ21OeUk0QkdsMlQ4dFdQbEl6Y0VWa3hhaWNQbGM5aWNpYkZUOTh6RE04ZlBnNWp2UkM2MmlhTHYyRHc5N2U4Uk5pY0pNSVpPQmNmVU1qRzZiQS82NDA/d3hfZm10PXBuZyZhbXA7dHA9d2VicCZhbXA7d3hmcm9tPTUmYW1wO3d4X2xhenk9MQ==.jpg"></p>
<h2><strong>例子与讲解</strong></h2>
<h2>1. 准备工作</h2>
<pre>
</pre>
<p>git clone https://github.com/QuantumLiu/wechat_callback.git</p>
<pre>
</pre>
<p>cd wechat_callback</p>
<p>需要用到的库：itchat, keras, numpy, scipy, matplotlib, _thread（py3）</p>
<p><strong>请确保 nvidia-smi 可用</strong>，如果 windows 的 cmd 里找不到命令，请手动将 nvidia-smi.exe 所在位置添加进环境变量。</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvbW1iaXoucXBpYy5jbi9tbWJpel9wbmcvVkJjRDAyakZoZ21OeUk0QkdsMlQ4dFdQbEl6Y0VWa3g0dURzQU0wbFdRQ0YzOThlTndSU1I4TEdVOWliODlVWXhyTHRmMVNCRDZpY3VHcDhVejhhV2ljTGcvNjQwP3d4X2ZtdD1wbmcmYW1wO3RwPXdlYnAmYW1wO3d4ZnJvbT01JmFtcDt3eF9sYXp5PTE=.jpg"></p>
<h2>2. 运行测试脚本</h2>
<pre>
</pre>
<p>python wechat_test.py</p>
<p>解析：</p>
<p>在 wechat_test.py 的开头，首先 import  wechat_utils</p>
<pre>
</pre>
<p>import wechat_utils #will login automaticly</p>
<pre>
</pre>
<p>#wechat_utils.sendmessage()isthe callback class</p>
<pre>
</pre>
<p>#wechat_utils.sendmessage()是 keras 的回调类，fit 时传入 callbacklist</p>
<p>在 wechat_utils.py 中：</p>
<pre>
</pre>
<p># Automaticly login when imported</p>
<pre>
</pre>
<p>#在被import时自动登录</p>
<pre>
</pre>
<p>#==============================================================================</p>
<pre>
</pre>
<p>itchat.auto_login(enableCmdQR=0.5,hotReload=True)</p>
<pre>
</pre>
<p>itchat.dump_login_status()#dump</p>
<p>可以看到，当 wechat_utils 被 import 时会调用 itchat.auto_login()，不出意外的话，将会在命令行显示二维码，需要使用手机微信扫码登录你的微信账号。</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvbW1iaXoucXBpYy5jbi9tbWJpel9wbmcvVkJjRDAyakZoZ21OeUk0QkdsMlQ4dFdQbEl6Y0VWa3hJTWYybEtyblpPY3NDb2NpYXI0czZuQzlkNEFWUTZRMUF0YmtxMUxmTDh1d2liYXY5QzJ3VXIzQS82NDA/d3hfZm10PXBuZyZhbXA7dHA9d2VicCZhbXA7d3hmcm9tPTUmYW1wO3d4X2xhenk9MQ==.jpg"></p>
<p>在测试脚本里我使用 numpy.random 来生成训练数据，搭建了一个多层的 FC 网络</p>
<pre>model = Sequential()</pre>
<pre>model.add(Dense(2048, input_dim=784))</pre>
<pre>model.add(Activation('relu'))</pre>
<pre>for i in range(9):</pre>
<pre>    model.add(Dense(2048))</pre>
<pre>    model.add(Activation('relu'))</pre>
<pre>model.add(Dense(1,activation='sigmoid'))</pre>
<pre> </pre>
<pre>x=np.random.rand(nb_sample,dim)   </pre>
<pre>y=np.random.randint(2,size=(nb_sample,1))</pre>
<p>调用插件非常简单，只需要在 fit 时把 wechat_utils.sendmessage() 这个 keras 的 Callback 类传入 Callbacklist。</p>
<p>model.fit(x=train_x,y=train_y,batch_size=batch_size,nb_epoch=60,validation_data=(val_x,val_y),callbacks=[wechat_utils.sendmessage()])</p>
<p>于是训练开始，手机会收到如下反馈：</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvbW1iaXoucXBpYy5jbi9tbWJpel9wbmcvVkJjRDAyakZoZ21OeUk0QkdsMlQ4dFdQbEl6Y0VWa3hWSm9EMXNtckEydUV0aWNRWWtpYzVpYjlYVGhYSm94dDdkSG40YXBoWUlLb0hJS3EwWWxTNFBGd0EvNjQwP3d4X2ZtdD1wbmcmYW1wO3RwPXdlYnAmYW1wO3d4ZnJvbT01JmFtcDt3eF9sYXp5PTE=.jpg"></p>
<p>现在，我们可以向它发送<strong>查询指令</strong>，指令一般包括<strong>关键词</strong>和<strong>参数</strong>，以获取图表为例，包含以下任意关键词将被识别为获取图表指令：</p>
<pre><code>[u'</code><code>获取图表','Show me the figure']</code></pre>
<p>参数则用{}或[]来指定，所有的指令均支持不指定参数，获取图表的默认参数是查询所有信息，例如：</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvbW1iaXoucXBpYy5jbi9tbWJpel9wbmcvVkJjRDAyakZoZ21OeUk0QkdsMlQ4dFdQbEl6Y0VWa3hOUk91aGJkcnhYbkhQNnpjWTZpY3dFVUE4VXpNTVJMOFVpYUZYOTdmaWIwZ01wRUNEaWFwbG12c1pBLzY0MD93eF9mbXQ9cG5nJmFtcDt0cD13ZWJwJmFtcDt3eGZyb209NSZhbXA7d3hfbGF6eT0x.jpg"></p>
<p>‘Show me the figure’ 触发了指令，{batches} 表示查询 batches 级别信息，[losshinge] 表示查询 loss 和 hinge 指标（一般的，同一属性参数用空格隔开）。</p>
<p>同理，['GPU','gpu',u'显卡'] 是 gpu 状态查询的关键词，用[]指定参数，如图，查询了 gpu 的显存和温度。GPU 参数是根据 nvidia-smi 的预置参数确定的，全部都是大写，具体可查询属性请看 GitHub 的 readme 或者阅读源码。</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvbW1iaXoucXBpYy5jbi9tbWJpel9wbmcvVkJjRDAyakZoZ21OeUk0QkdsMlQ4dFdQbEl6Y0VWa3hlTTIyNXFZSXRkdmE0dmlhakVrbU8xOUVMV0E0SFVtMGNWTTNhaDYzcDNtaWJBY1oxcEhwdWljaWN3LzY0MD93eF9mbXQ9cG5nJmFtcDt0cD13ZWJwJmFtcDt3eGZyb209NSZhbXA7d3hfbGF6eT0x.jpg"></p>
<p>关机指令关键词是 [u'关机','Shut down','Shut down the computer',u'别浪费电了',u'洗洗睡吧']，使用 {sec} 和 [name] 指定等待时间和保存文件名,文件名不包括.h5。默认保存模型，如果不想保存，可以在消息中包含 [u'不保存模型',"don't save"] 比如：</p>
<pre>
</pre>
<p><code>Shut down now{120},don't save</code></p>
<p>取消关机只需要包含 [u'取消','cancel','aaaa'] 就可以了，也就是说如果着急的话打一串 a 发过去也是可以的。</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvbW1iaXoucXBpYy5jbi9tbWJpel9wbmcvVkJjRDAyakZoZ21OeUk0QkdsMlQ4dFdQbEl6Y0VWa3hOanlENGo3S293Y2ZhWUJyVTBlWVpIQ05BVmtadU1FbklpYm5kVHlZck04ck9xcDBNd2dLa2N3LzY0MD93eF9mbXQ9cG5nJmFtcDt0cD13ZWJwJmFtcDt3eGZyb209NSZhbXA7d3hfbGF6eT0x.jpg"></p>
<p>立刻停止训练的关键词是 ['Stopnow',"That's enough",u'停止训练',u'放弃治疗'] （《西部世界》看多了）。</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvbW1iaXoucXBpYy5jbi9tbWJpel9wbmcvVkJjRDAyakZoZ21OeUk0QkdsMlQ4dFdQbEl6Y0VWa3hXaWNPZExudHRxUVpwTnBJTUVGMUZFRExqbkh2SmM4TGZwcmNhVm0zMlNPc0xnRlNtcjJFU3p3LzY0MD93eF9mbXQ9cG5nJmFtcDt0cD13ZWJwJmFtcDt3eGZyb209NSZhbXA7d3hfbGF6eT0x.jpg"></p>
<p>指定停止 epoch 的关键词是 ‘Stop at’，参数可以直接用整数表示，不需要 []。</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvbW1iaXoucXBpYy5jbi9tbWJpel9wbmcvVkJjRDAyakZoZ21OeUk0QkdsMlQ4dFdQbEl6Y0VWa3gzQ0tYYk9xZGlia1d3YXJqamhOQ0ppYUZYUmliVjZEYlB1cU1qSXlRMFl1MFhHeUdocDJ0WVh3YlEvNjQwP3d4X2ZtdD1wbmcmYW1wO3RwPXdlYnAmYW1wO3d4ZnJvbT01JmFtcDt3eF9sYXp5PTE=.jpg"></p>
<h2><strong>命令与关键词列表</strong></h2>
<p><strong>1. 远程停止训练</strong></p>
<p>关键词列表：</p>
<p>['Stop now',"That'senough",u'停止训练',u'放弃治疗']  </p>
<p>说明：发送的消息中包含任意一项都可触发命令。将在当前epoch结束后停止训练。无参数。</p>
<p><strong>2. 远程关机</strong></p>
<p><strong><br /></strong></p>
<p>关键词列表：</p>
<p>[u'关机','Shut down','Shut down the computer',u'别浪费电了',u'洗洗睡吧']</p>
<p>说明：发在指定秒数后关机，用 <strong>{sec} </strong>和 <strong>[name] </strong>指定<strong>参数等待时间和保存文件名</strong>，文件名不包括 .h5。如果同时包含 [u'不保存模型',"don't save"]，则不会保存模型。例：发送 'Shut down now [test]{120}'，电脑将在 120 秒后关机，将模型保存为 test.h5。若发送 'Shut down now{120},don't save'，则模型将不会被保存。</p>
<p><strong>3. 取消关机</strong></p>
<p><strong><br /></strong></p>
<p>关键词列表：</p>
<p>[u'取消','cancel','aaaa']</p>
<p>说明：发送的消息中包含任意一项都可触发命令。无参数。</p>
<p><strong>4. 获取图表</strong></p>
<p><strong><br /></strong></p>
<p>关键词列表：</p>
<p>[u'获取图表','Show me the figure']</p>
<p>说明：发送的消息中包含任意一项都可触发命令。通过<strong> [metrics] </strong>和<strong> {level} </strong>指定参数，如果没有指定则皆默认为<strong> ’all'</strong>。例：手机发送"获取图表[loss]{batches}"，会收到一个 jpg 格式的 loss 随 batches 变化的图片。手机发送"获取图表",则会得到两张图片，分别是所有指标随 batch 和 epoch 的变化。</p>
<p><strong>5. 指定训练停止轮数</strong></p>
<p><strong><br /></strong></p>
<p>关键词列表：</p>
<p>'Stop at '</p>
<p>参数可以直接用整数表示，不需要 []。例：手机发送“Stop at：8”，训练将在 epoch8 完成后停止。</p>
<p><strong>6. 查询显卡状态</strong></p>
<p><strong><br /></strong></p>
<p>关键词列表：</p>
<p>['GPU','gpu',u'显卡']</p>
<p>参数使用 [TYPE] 来指定，GPU 参数是根据 nvidia-smi 的预置参数确定的，全部都是大写，在 [] 内用空格分隔。</p>
<p>可用参数列表：</p>
<p>['MEMORY', 'UTILIZATION', 'ECC', 'TEMPERATURE','POWER', 'CLOCK', 'COMPUTE', 'PIDS', 'PERFORMANCE','SUPPORTED_CLOCKS,PAGE_RETIREMENT', 'ACCOUNTING']</p>
<p>例：发送'gpu[MEMORY]'或者'显卡[MEMORY]'查询显存使用；发送'GPU[MEMORYTEMPERATURE]'查询显存和温度。</p>
<h2><strong>总结</strong></h2>
<p>这个项目从有想法算起到写注释、开 GitHub、写知乎不过两天半，做的很匆忙也很粗糙，特别是画图的细节和多线程的处理。</p>
<p>我只是一名阿语专业大一学生（休学ing），水平十分有限，恳请各位多加指点，提高我的姿势水平，如果这个项目能给你带来一点点便利或者灵感，那么我将感到十分荣幸与欣慰。</p>
<p>来源：paperweekly</p>
<p><a href="https://mp.weixin.qq.com/s/BQwv2hn-b4Mgb59nsOq0sA" rel="external nofollow noreferrer">原文链接</a></p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-19 17:56:42</div>
		
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.iamivan.net/tag/%e6%b7%b1%e5%ba%a6%e5%ad%a6%e4%b9%a0/" title="深度学习">深度学习</a>, <a href="https://www.iamivan.net/tag/gpu/" title="GPU">GPU</a>, <a href="https://www.iamivan.net/tag/https/" title="HTTPS">HTTPS</a>, <a href="https://www.iamivan.net/tag/%e6%8f%92%e4%bb%b6/" title="插件">插件</a>, <a href="https://www.iamivan.net/tag/python/" title="python">python</a>, <a href="https://www.iamivan.net/tag/%e8%84%9a%e6%9c%ac/" title="脚本">脚本</a>, <a href="https://www.iamivan.net/tag/%e7%9b%91%e6%8e%a7/" title="监控">监控</a>        </div> -->
	</section>
	
	

		<div id="similar">

		<h3>用微信控制深度学习训练的Keras插件 - #Geek Time的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/boR37Xz.html" rel="bookmark">深度学习训练，选择P100就对了</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				1.背景 去年4月,NVIDIA推出了Tesla P100加速卡,速度是NVIDIA之前高端系统的12倍.同年9月的GTC China 2016大会,NVIDIA又发布了Tesla P4.P40两款深度学习芯片.Tesla P100主攻学习和训练任务,而Tesla P4&amp;P40主要负责图像.文字和语音识别. 同为Pascal架构且运算能力接近的P100和P40常常被拿来对比,单看Spec上运算能力,似乎P40比P100的深度学习性能更好,但实际上呢?本文就通过使用NVCaffe.MXNet.Te			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zGnDAvp.html" rel="bookmark">NVIDIA令深度学习训练性能翻一番</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				NVIDIA发布了其 GPU 加速深度学习软件的更新版本,这些软件将令深度学习训练的性能翻一番. 新软件将让数据科学家和研究人员能够通过更快的模型训练和更复杂的模型设计来创造更准确的神经网络,从而加速其深度学习项目和产品的开发工作. NVIDIA DIGITS  深度学习 GPU 训练系统第 2 版 (DIGITS 2) 和 NVIDIA CUDA 深度神经网络库第 3 版 (cuDNN 3) 可提供大幅提升的性能和全新的功能. 对数据科学家来说,DIGITS 2 现在能够在多颗高性能 GPU			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MgR89Eb.html" rel="bookmark">继 OpenAI 之后，DeepMind 开源深度学习训练平台 DeepMind Lab</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				编者按:今年四月,由马斯克和知名风投专家 Peter Thiel.Y Combinator 创始人 Sam Altman 共同创立的 AI 研究组织对外开放了其 AI 训练平台 OpenAI Gym.近日,该组织宣布还将开源测试和训练 AI 通用能力的平台 Universe,届时 Universe 将提供 1000 多种不同的游戏和训练测试环境.今天,据彭博社消息,谷歌 DeepMind 实验室也将向大众及其他开发者开放其用于众多实验的迷宫类游戏平台. DeepMind 宣布,将把这一 AI 训			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/z75RoqM.html" rel="bookmark">深度学习库 Keras 2 重磅发布，与 TensorFlow 联系更紧密</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				昨天,著名深度学习开源库 Keras 通过官方博客正式发布了全新版本:Keras 2. 根据官方介绍,此次更新的重点有两个: Keras 2 API 将作为 TensorFlow 框架的一部分直接向用户提供支持: Keras 2 API 经过了重新设计,将成为团队第一个长期支持(long-term-support)的 API. Keras 表示:从 2015 年 3 月发布第一个版本以来,有数以百计的开发人员对 Keras 的开源代码做了完善和拓展,数以千计的热心用户在社区对 Keras 的发展			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zGA8yEM.html" rel="bookmark">机器学习和深度学习的最佳框架大比拼</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				在过去的一年里,咱们讨论了六个开源机器学习和/或深度学习框架:Caffe,Microsoft Cognitive Toolkit(又名CNTK 2),MXNet,Scikit-learn,Spark MLlib和TensorFlow.如果把网撒得大些,可能还会覆盖其他几个流行的框架,包括Theano(一个10年之久的Python深度学习和机器学习框架),Keras(一个Theano和TensorFlow深度学习的前端),DeepLearning4j(Java和Scala在Hadoop和Spark			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/bE6OK6M.html" rel="bookmark">手把手教你安装深度学习软件环境（附代码）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				为了进行强化学习研究,我最近购置了一台基于 Ubuntu 和英伟达 GPU 的深度学习机器.尽管目前在网络中能找到一些环境部署指南,但目前仍然没有全面的安装说明.另外,我也不得不阅读了很多文档来试图理解安装细节--其中的一些并不完整,甚至包含语法错误.因此,本文试图解决这个问题,提供一个详尽的软件环境安装指南. 本文将指导你安装 操作系统(Ubuntu) 4 种驱动和库(GPU 驱动.CUDA.cuDNN 和 pip) 5 种 Python 深度学习库(TensorFlow.Theano.CNT			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/ze7ka0M.html" rel="bookmark">10个深度学习软件的安装指南（附代码）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				由于近期论文的需要,我搭建了一个基于 Ubuntu 和英伟达的深度学习环境.尽管已经有很多非常棒的关于英伟达驱动和 CUDA 的安装指南, 但依然没有详尽的深度学习环境搭建指南.另外,我需要查阅很多文档来熟悉细节,其中一些细节还有待完善,甚至还有一些包含语法错误.因此我决定把我这段时间查阅的文档(见参考链接)做个总结. 该指南会安装如下内容 操作系统(Ubuntu) 4 个驱动和库 5 个 Python DL 库(TensorFlow,Theano,CNTK,Keras 和 PyTorch) 下			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/bKkWXnb.html" rel="bookmark">大规模深度学习优化技术在PAI平台中的应用及实践</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				1. 前言 自2012年Deep Learning的代表模型AlexNet在ImageNet大赛中力压亚军,以超过10个百分点的绝对优势夺得头筹之后,依托于建模技术的进步.硬件计算能力的提升.优化技术的进步以及海量数据的累积,Deep Learning在语音.图像以及文本等多个领域不断推进,相较于传统作法取得了显著的效果提升.   工业界和学术界也先后推出了用于Deep Learning建模用途的开源工具和框架,包括Caffe.Theano.Torch.MXNet.TensorFlow.Chai			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/bBZPNob.html" rel="bookmark">GitHub 上 57 款最流行的开源深度学习项目</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				GitHub 上 57 款最流行的开源深度学习项目 本文整理了 GitHub 上最流行的 57 款深度学习项目(按 stars 排名).最后更新:2016.08.09 1.TensorFlow 使用数据流图计算可扩展机器学习问题 TensorFlow 是谷歌的第二代机器学习系统,按照谷歌所说,在某些基准测试中,TensorFlow 的表现比第一代的 DistBelief 快了2倍. TensorFlow 内建深度学习的扩展支持,任何能够用计算流图形来表达的计算,都可以使用 TensorFlow.			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/vbQ9dQb.html" rel="bookmark" class="title">查找消耗CPU较大的sql语句</a>
					<div>
						语句 查找消耗CPU较大的sql语句 一.使用unix系统命令查看资源 #sar 1 9 12:15:27      73      27       0       012:15:28      7 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/5zOgW5z.html" rel="bookmark" class="title">如何获取一个变量的名字</a>
					<div>
						  比如, 我提供一个查询服务, 用户可以提交一个人的名字和年龄做为查询条件. 假设我要查询一个名字叫做&quot;laruence&quot;, 年龄是27的人, 我认为这个人的定义的查询token ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zGJEJnp.html" rel="bookmark" class="title">Word2007文档插入或删除水印的设置</a>
					<div>
						  在平时阅读一本参考资料或者机密性文件时,常常会看到,文档的底部背景上常印有&quot;机密&quot;或者某些著作者的名称,防止被盗用.其实,该功能在Word2007文档上也是可以实现的,只要插入 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MxWgyRb.html" rel="bookmark" class="title">如何检测浏览器是否安装了视频插件</a>
					<div>
						  将如下代码加入HTML的区: var myPlugin =navigator.plugins[&quot;Shockwave&quot;]; if (myPlugin) document.writ ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/ze7mY0M.html" rel="bookmark" class="title">win7系统如何用iTunes恢复备份文件</a>
					<div>
						  win7系统如何用iTunes恢复备份文件 解决方法1: 1.打开你的iTunes,选择菜单栏的「商店--信任此设备」; 2.随后在弹出来的对话框中输入你的Apple id跟密码,确认授权; 解决 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MYRx2Vp.html" rel="bookmark" class="title">C&plus;&plus; vector 值得计数问题</a>
					<div>
						问题描述 C++ vector 值得计数问题 问题描述: 利用一个vector 取储存一组结构体 结构体=int(A)+string+int(B) 现在要对两个int 变量 进行计数 请问一下,应该怎 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bo7VOjb.html" rel="bookmark" class="title">阿里云快速部署Kubernetes - VPC环境</a>
					<div>
						本文展示了一个在阿里云VPC网络上快速部署一个安全的kubernetes集群的方法,安装使用kubeadm工具,这个工具是k8s-release1.5的一部分(注意kubeadm还处在beta版本,欢 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bBZOXob.html" rel="bookmark" class="title">UIImagePickerController在iPhone和iPad中用法的一点不同&lbrack;转&rsqb;</a>
					<div>
						我们知道,在iPhone中获取照片库常用的方法如下:   UIImagePickerController *m_imagePicker = [[UIImagePickerController allo ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/My364lz.html" rel="bookmark" class="title">JSP基础3</a>
					<div>
						&lt;%@ page contentType=&quot;text/html; charset=gb2312&quot; language=&quot;java&quot; import=&quot ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zZEPj6p.html" rel="bookmark" class="title">mysqlslap</a>
					<div>
						PS: 还在翻译中,虽然翻译得很水,很不专业,慢慢有了一定的术语积累后,我会慢慢努力调整滴! mysqlslap - Load Emulation Client mysqlslap是mysql服务器的 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MqA6K2M.html" rel="bookmark" class="title">printf-c语言代码问题，麻烦大家帮忙看一下~~</a>
					<div>
						问题描述 c语言代码问题,麻烦大家帮忙看一下~~ 参加期中考试的人数约在 380~450 人之间,总平均分为 76 分,男生的平均分为 75 分,女生的平均分为 80.1 分,问男女生各有多少人? # ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zeRWxOb.html" rel="bookmark" class="title">root login-Linux 小型机 root 无法登陆本机</a>
					<div>
						问题描述 Linux 小型机 root 无法登陆本机 使用正确的root密码提示:Permission denied. 使用错误的root密码提示:incorrect 系统版本:Red Hat Ent ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p5Zjgaz.html" rel="bookmark" class="title">【调研】大家写技术博客的初衷是什么</a>
					<div>
						问题描述 [调研]大家写技术博客的初衷是什么 最近在孵化一个新的项目,借此想了解一下大家写技术博客的初衷有哪些? 我个人能想到的可能就是以下几个方面: 工作中解决了一个具体的问题,然后写一篇博客记录下 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zDe2NLb.html" rel="bookmark" class="title">js移动端，触摸时候滚动条问题</a>
					<div>
						问题描述 js移动端,触摸时候滚动条问题 请问,如何在移动端上,触摸时候显示Y方向滚动条,没有触摸时滚动条隐藏? 内容是如何随着触摸屏幕变动的,有滚动条时候是否只要直接滑动页面就行吗?如果没有滚动条的 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pPkYR0M.html" rel="bookmark" class="title">算法洗脑系列（8篇）&mdash;&mdash;第二篇 递归思想</a>
					<div>
						   今天说说递归思想,在我们编码时,有的时候递归能够让我们的算法更加通俗易懂,并且代码量也是大大的减少.比如我先前的系列中说到了 关于树的&quot;先序,中序和后序&quot;遍历,那么看看用递归 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
									<a href="https://www.iamivan.net/a/MlLR0DM.html" class="thumbnail">
				<img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1nLmJsb2cuY3Nkbi5uZXQvMjAxNzA0MDUwMDQxNTAyNzI/d2F0ZXJtYXJrLzIvdGV4dC9hSFIwY0RvdkwySnNiMmN1WTNOa2JpNXVaWFF2Y1hGZk1qVTRNVGs0TWpjPS9mb250LzVhNkw1TDJUL2ZvbnRzaXplLzQwMC9maWxsL0kwSkJRa0ZDTUE9PS9kaXNzb2x2ZS83MC9ncmF2aXR5L1NvdXRoRWFzdA==.jpg">
							</a>
							<div class="info"   >
					<a href="https://www.iamivan.net/a/MlLR0DM.html" rel="bookmark" class="title">C&num;连接MYSQL数据库并进行查询</a>
					<div>
						之前用MFC开发结果界面太难看被pass了,要求用C#重新来开发&gt;_&lt;,不过终于摆脱VC6.0的蛋疼操作了Y. 先来连接数据库 (1)用c#连接MYSQL数据库需要用到mysql-conn ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pmBG6lz.html" rel="bookmark" class="title">苹果连续四年成为全球最具价值品牌 前十有六家科技公司</a>
					<div>
						据国外媒体报道称,国际品牌咨询公司Interbrand日前发布了&lt;2016年全球最佳品牌&gt;(2016 Best Global Brands report)报告,其中苹果连续第4年成为全球最 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pX0NkQp.html" rel="bookmark" class="title">糯米网金逸观影券有效期缩短一个半月</a>
					<div>
						糯米团网页上显示有效期截止到10月31日 环球网青岛频道9月18日消息 近日,青岛市民孙女士向环球网青岛频道热线(0532-66568111)反映,自己于8月4日在糯米团购买了四张金逸观影券,观影券的 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M60wvLz.html" rel="bookmark" class="title">诺西收购北电CDMA业务和LTE资产</a>
					<div>
						6月20日消息,苹果希望3GS版iPhone能够掀起新一波销售狂潮.3GS版iPhone配置有速度更快的处理器.更大的存储容量和支持自动对焦的摄像头,运行新版操作系统.苹果从两周前开始接受网上预订.  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pnRXg2p.html" rel="bookmark" class="title">数据仓库 hadoop-数据仓库基础数据量大，ETL处理速度慢，查询慢，hadoop能否解决问题？如何迁移到hadoop？</a>
					<div>
						问题描述 数据仓库基础数据量大,ETL处理速度慢,查询慢,hadoop能否解决问题?如何迁移到hadoop? 1.基础数据主表2亿以上数据 2.基础层到中间层的汇总处理(每天处理),ETL处理比较花时 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/b22Bq4b.html" rel="bookmark" class="title">编程-给出如下算法，请分析时间复杂度。求教</a>
					<div>
						问题描述 给出如下算法,请分析时间复杂度.求教 给出如下算法,请分析时间复杂度. 1. Type game(Type group[],int n) 2. { 3. int j,i = n; 4. wh ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Mq7wAez.html" rel="bookmark" class="title">技术-最近在抓取数据的时候遇到个问题，请问大神如何抓取内容我用的是C&num;</a>
					<div>
						问题描述 最近在抓取数据的时候遇到个问题,请问大神如何抓取内容我用的是C# &lt;html&gt;&lt;head&gt;&lt;link title=&quot;将较长的行自动换行&quot; h ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MrqRx4b.html" rel="bookmark" class="title">联想网御加入CSA云安全联盟</a>
					<div>
						近日,国内一线安全厂商联想网御正式获批加入全球&quot;云安全联盟&quot;CSA(Cloud Security Alliance).作为该联盟成员,联想网御将与国内外一线主流云安全厂商合作,共同 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zJOZqDb.html" rel="bookmark" class="title">相比Instagram之类图片应用专注于记录分享</a>
					<div>
						魔漫.微漫.Epica等产品的迭出告诉我们,相比Instagram之类图片应用专注于记录分享,这一波图片应用越来越看重留给用户的创作空间,大多是为图片中的主角(很多时候是Selfie)创造一个全新的场 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Mlm1VVp.html" rel="bookmark" class="title">php伪静态之APACHE篇&lowbar;php实例</a>
					<div>
						1.检测Apache是否支持mod_rewrite通过php提供的phpinfo()函数查看环境配置,通过Ctrl+F查找到&quot;Loaded Modules&quot;,其中列出了所有apac ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zGrO6Ep.html" rel="bookmark" class="title">css之强制换行代码&lpar;1&sol;2&rpar;</a>
					<div>
						&lt;div id=&quot;wrap&quot;&gt;正常文字的换行(亚洲文字和非亚洲文字)元素拥有默认的white-space:normal,当定义&lt;/div&gt; css  代码如 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MR1oLdb.html" rel="bookmark" class="title">jquery validate 验证select为什么要两次才通过</a>
					<div>
						问题描述 jquery validate 验证select为什么要两次才通过 在validate中验证select下拉选项,第一次选了后,错误提示还在,再选一次提示就没有了,求解 解决方案 jquer ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MAk3QKz.html" rel="bookmark" class="title">急求！！用 vb&period;net ado 实现sql数据库 查插删！！！实现下图</a>
					<div>
						问题描述 解决方案 解决方案二:亲,你的浏览器过时了,请立即更换Chrome浏览器.解决方案三:随便弄本教ado的书,或者你们自己的教材,一步一步照着抄就弄出来了解决方案四:随便弄本教ado的书,或者 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pn8gnjb.html" rel="bookmark" class="title">AJAX中URL链接地址的问题</a>
					<div>
						问题描述 functionMyreport1(){varmyDate=newDate();$.ajax({url:&quot;http://product.uzai.com:81/Product.as ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pLBWZkb.html" rel="bookmark" class="title">数据结构之红黑树详解&lowbar;C 语言</a>
					<div>
						1.简介 红黑树是一种自平衡二叉查找树.它的统计性能要好于平衡二叉树(AVL树),因此,红黑树在很多地方都有应用.在C++ STL中,很多部分(目前包括set, multiset, map, mult ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>热搜</span>
		</div>
		<div class="box-content">
					</div>
	</div>


</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 iVAN        | info#iamivan.net        | 11 q. 0.036 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <!-- <script src="/assets/js/jquery.js"></script>
  <script src="/assets/js/bootstrap.min.js"></script> -->
  <div style=" display: none ";>
  </div>

<script src="/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
    </script>
</body>
</html>
